//----------------------------------------------------------------------------------
//aviutlvOC AiOngF␳
// Copyright (c) 2005  N099
//----------------------------------------------------------------------------------
#include <windows.h>
#include <mmintrin.h>
#include <malloc.h>
#include <math.h>

#include "filter.h"
#include "util.h"

//---------------------------------------------------------------------
//tB^\̒`
//---------------------------------------------------------------------
#define TRACK_N 3
TCHAR *track_name[] = {"mode", "x", "noise" };
int   track_default[] = { 0, 64, 48 };
int   track_s[] = { 0, 0, 0 };
int   track_e[] = { 4, 128, 128 };
enum  { T_MODE, T_GAIN, T_NOISE };

#define CHECK_N 3
TCHAR *check_name[] = { "640", "MMX", "test" };
int    check_default[] = { 1, 1, 0 };
enum { C_640, C_MMX, C_TEST };

FILTER_DLL filter = {
  FILTER_FLAG_EX_INFORMATION, 0,0,
  "AiOF␳",
  TRACK_N, track_name, track_default, track_s, track_e,
  CHECK_N, check_name, check_default,
  func_proc,
  NULL,
  func_exit,
  NULL, NULL, NULL, NULL, NULL, 0,
  "atv_color by N099, ver1.3",
  NULL,  NULL,

};

//---------------------------------------------------------------------
// global
//---------------------------------------------------------------------
short *g_icr_g = NULL;
short *g_qcb_g = NULL;
short *g_icr = NULL;
short *g_qcb = NULL;

//---------------------------------------------------------------------
//     tB^\̂̃|C^n֐
//---------------------------------------------------------------------
EXTERN_C FILTER_DLL __declspec(dllexport) * __stdcall GetFilterTable( void )
{
  return &filter;
}

//---------------------------------------------------------------------
// IɌĂ΂֐
//---------------------------------------------------------------------
BOOL func_exit( FILTER *fp )
{
  if(NULL != g_icr_g){
    _aligned_free(g_icr_g);
    g_icr_g = NULL;
  }
  if(NULL != g_qcb_g){
    _aligned_free(g_qcb_g);
    g_qcb_g = NULL;
  }
  if(NULL != g_icr){
    _aligned_free(g_icr);
    g_icr = NULL;
  }
  if(NULL != g_qcb){
    _aligned_free(g_qcb);
    g_qcb = NULL;
  }

  return TRUE;
}

//---------------------------------------------------------------------
// ̈m
//---------------------------------------------------------------------
BOOL malloc_temp(int w)
{
  static int width = -1;

  if(w == width && g_icr_g && g_qcb_g && g_icr && g_qcb){
    return TRUE;
  }

  // TCYωꍇÄfree
  func_exit(NULL);

  // MMXp4C
  g_icr_g = _aligned_malloc((w + 2*GB) * sizeof(short) * 4, 16);
  g_qcb_g = _aligned_malloc((w + 2*GB) * sizeof(short) * 4, 16);
  g_icr = _aligned_malloc(w * sizeof(short) * 4, 16);
  g_qcb = _aligned_malloc(w * sizeof(short) * 4, 16);

  if(NULL == g_icr_g || NULL == g_qcb_g || NULL == g_icr || NULL == g_qcb){
    func_exit(NULL);
    return FALSE;
  }
  
  width = w;
  return TRUE;
}

//---------------------------------------------------------------------
// tB^֐
//---------------------------------------------------------------------
BOOL func_proc( FILTER *fp,FILTER_PROC_INFO *fpip )
{
  int i,j;
  PIXEL_YC *ycp;
  void (*lpfx)(short *dst, const short *src, int n);
  void (*lpfx_mmx)(short *dst, const short *src, int n);

  // eXg\
  if(fp->check[C_TEST]){
    double d,a;
    
    _mm_empty();
    //tB^шmFp
    for(i=0; i<fpip->h-8; ++i){
      d = fp->check[C_640] ? 3.1415926535/640 : 3.1415926535/720;
      d *= 2.0*i;
      
      ycp = fpip->ycp_edit + i*fpip->max_w;
      for(j=0; j<fpip->w; ++j){
        ycp->y = 2048;
        ycp->cr = (short)(1024 * cos(j*d));
        ycp->cb = (short)(1024 * cos(j*d));
        ++ycp;
      }
      for( ; j<fpip->w; ++j){
      }
    }

    // -I,Q\
    d = 33.0 * 3.1415926535 / 180.0;
    a = 2048.0 * 40.0 / 100.0;
    for( ; i<fpip->h; ++i){
      ycp = fpip->ycp_edit + i*fpip->max_w;
      for(j=0; j<fpip->w/2 - 16; ++j){
        ycp->y = 0;
        ycp->cr = (short)(- a * (1.14/1.402) * cos(d));
        ycp->cb = (short)(  a * (2.03/1.772) * sin(d));
        ++ycp;
      }
      for( ; j<fpip->w/2 + 16; ++j){
        ycp->y = 0;
        ycp->cr = 0;
        ycp->cb = 0;
        ++ycp;
      }
      for( ; j<fpip->w; ++j){
        ycp->y = 0;
        ycp->cr = (short)(a * (1.14/1.402) * sin(d));
        ycp->cb = (short)(a * (2.03/1.772) * cos(d));
        ++ycp;
      }
    }
  } // eXg\܂

  if(0 == fp->track[T_MODE])
    return TRUE;

  if(!malloc_temp(fpip->max_w))
    return FALSE;

  // LPF I
  if(fp->check[C_640]){
    lpfx = lpf640;
    lpfx_mmx = lpf640_mmx;
  }else{
    lpfx = lpf720;
    lpfx_mmx = lpf720_mmx;
  }

  i = fpip->h;
  if(1 == fp->track[T_MODE]){ // LPF̂
    if(fp->check[C_MMX]){
      for( ; i>3; i-=4){
        ycp = fpip->ycp_edit + (fpip->h - i)*fpip->max_w;
      
        unpack_color4(g_icr_g, g_qcb_g, ycp, fpip->w/2, fpip->max_w);
        lpfx_mmx(g_icr, &g_icr_g[4*GB], fpip->w/2);
        lpfx_mmx(g_qcb, &g_qcb_g[4*GB], fpip->w/2);
        interpolate_color_mmx(g_icr_g, g_icr, fpip->w/2);
        interpolate_color_mmx(g_qcb_g, g_qcb, fpip->w/2);
        pack_color4(ycp, g_icr_g, g_qcb_g, fpip->w, fpip->max_w);
      }
      _mm_empty();
    }
    for( ; i>0; --i){
      ycp = fpip->ycp_edit + (fpip->h - i)*fpip->max_w;
      
      unpack_color(g_icr_g, g_qcb_g, ycp, fpip->w/2);
      lpfx(g_icr, &g_icr_g[GB], fpip->w/2);
      lpfx(g_qcb, &g_qcb_g[GB], fpip->w/2);
      interpolate_color(g_icr_g, g_icr, fpip->w/2);
      interpolate_color(g_qcb_g, g_qcb, fpip->w/2);
      pack_color(ycp, g_icr_g, g_qcb_g, fpip->w);
    }
  }else if(2 == fp->track[T_MODE]){ // mode1 + I
    if(fp->check[C_MMX]){
      for( ; i>3; i-=4){
        ycp = fpip->ycp_edit + (fpip->h - i)*fpip->max_w;
        
        unpack_color4(g_icr_g, g_qcb_g, ycp, fpip->w/2, fpip->max_w);
        crcb2iq_mmx(g_icr_g, g_qcb_g, fpip->w*2 + 8*GB);
        lpfx_mmx(g_icr, &g_icr_g[4*GB], fpip->w/2);
        lpfx_mmx(g_qcb, &g_qcb_g[4*GB], fpip->w/2);
        add_hi_mmx(g_icr, &g_icr_g[4*GB], fpip->w*2, fp->track[T_GAIN]);
        iq2crcb_mmx(g_icr, g_qcb, fpip->w*2);
        interpolate_color_mmx(g_icr_g, g_icr, fpip->w/2);
        interpolate_color_mmx(g_qcb_g, g_qcb, fpip->w/2);
        pack_color4(ycp, g_icr_g, g_qcb_g, fpip->w, fpip->max_w);
      }
      _mm_empty();
    }
    for( ; i>0; --i){
      ycp = fpip->ycp_edit + (fpip->h - i)*fpip->max_w;
        
      unpack_color(g_icr_g, g_qcb_g, ycp, fpip->w/2);
      crcb2iq(g_icr_g, g_qcb_g, fpip->w/2 + 2*GB);
      lpfx(g_icr, &g_icr_g[GB], fpip->w/2);
      lpfx(g_qcb, &g_qcb_g[GB], fpip->w/2);
      add_hi(g_icr, &g_icr_g[GB], fpip->w/2, fp->track[T_GAIN]);
      iq2crcb(g_icr, g_qcb, fpip->w/2);
      interpolate_color(g_icr_g, g_icr, fpip->w/2);
      interpolate_color(g_qcb_g, g_qcb, fpip->w/2);
      pack_color(ycp, g_icr_g, g_qcb_g, fpip->w);
    }
  }else if(3 == fp->track[T_MODE]){ // mode2 + half band LPF
    if(fp->check[C_MMX]){
      for( ; i>3; i-=4){
        ycp = fpip->ycp_edit + (fpip->h - i)*fpip->max_w;
        
        unpack_color4(g_icr_g, g_qcb_g, ycp, fpip->w/2, fpip->max_w);
        crcb2iq_mmx(g_icr_g, g_qcb_g, fpip->w*2 + 8*GB);
        lpfx_mmx(g_icr, &g_icr_g[4*GB], fpip->w/2);
        lpfx_mmx(g_qcb, &g_qcb_g[4*GB], fpip->w/2);
        lpfh_mmx(&g_qcb_g[4*GB], &g_icr_g[4*GB], fpip->w/2);
        add_hi_mmx(g_icr, &g_qcb_g[4*GB], fpip->w*2, fp->track[T_GAIN]);
        iq2crcb_mmx(g_icr, g_qcb, fpip->w*2);
        interpolate_color_mmx(g_icr_g, g_icr, fpip->w/2);
        interpolate_color_mmx(g_qcb_g, g_qcb, fpip->w/2);
        pack_color4(ycp, g_icr_g, g_qcb_g, fpip->w, fpip->max_w);
      }
      _mm_empty();
    }
    for( ; i>0; --i){
      ycp = fpip->ycp_edit + (fpip->h - i)*fpip->max_w;

      unpack_color(g_icr_g, g_qcb_g, ycp, fpip->w/2);
      crcb2iq(g_icr_g, g_qcb_g, fpip->w/2 + 2*GB);
      lpfx(g_icr, &g_icr_g[GB], fpip->w/2);
      lpfx(g_qcb, &g_qcb_g[GB], fpip->w/2);
      lpfh(&g_qcb_g[GB], &g_icr_g[GB], fpip->w/2);
      add_hi(g_icr, &g_qcb_g[GB], fpip->w/2, fp->track[T_GAIN]);
      iq2crcb(g_icr, g_qcb, fpip->w/2);
      interpolate_color(g_icr_g, g_icr, fpip->w/2);
      interpolate_color(g_qcb_g, g_qcb, fpip->w/2);
      pack_color(ycp, g_icr_g, g_qcb_g, fpip->w);
    }
  }else if(4 == fp->track[T_MODE]){ // mode3 + RAO
    if(fp->check[C_MMX]){
      for( ; i>3; i-=4){
        ycp = fpip->ycp_edit + (fpip->h - i)*fpip->max_w;
        
        unpack_color4(g_icr_g, g_qcb_g, ycp, fpip->w/2, fpip->max_w);
        crcb2iq_mmx(g_icr_g, g_qcb_g, fpip->w*2 + 8*GB);
        lpfx_mmx(g_icr, &g_icr_g[4*GB], fpip->w/2);
        lpfx_mmx(g_qcb, &g_qcb_g[4*GB], fpip->w/2);
        lpfh_mmx(&g_qcb_g[4*GB], &g_icr_g[4*GB], fpip->w/2);
        add_hi_core_mmx(g_icr, &g_qcb_g[4*GB],
                        fpip->w*2, fp->track[T_GAIN], fp->track[T_NOISE]);
        iq2crcb_mmx(g_icr, g_qcb, fpip->w*2);
        interpolate_color_mmx(g_icr_g, g_icr, fpip->w/2);
        interpolate_color_mmx(g_qcb_g, g_qcb, fpip->w/2);
        pack_color4(ycp, g_icr_g, g_qcb_g, fpip->w, fpip->max_w);
      }
      _mm_empty();
    }
    for( ; i>0; --i){
      ycp = fpip->ycp_edit + (fpip->h - i)*fpip->max_w;
      
      unpack_color(g_icr_g, g_qcb_g, ycp, fpip->w/2);
      crcb2iq(g_icr_g, g_qcb_g, fpip->w/2 + 2*GB);
      lpfx(g_icr, &g_icr_g[GB], fpip->w/2);
      lpfx(g_qcb, &g_qcb_g[GB], fpip->w/2);
      lpfh(&g_qcb_g[GB], &g_icr_g[GB], fpip->w/2);
      add_hi_core(g_icr, &g_qcb_g[GB], fpip->w/2,
                  fp->track[T_GAIN], fp->track[T_NOISE]);
      iq2crcb(g_icr, g_qcb, fpip->w/2);
      interpolate_color(g_icr_g, g_icr, fpip->w/2);
      interpolate_color(g_qcb_g, g_qcb, fpip->w/2);
      pack_color(ycp, g_icr_g, g_qcb_g, fpip->w);
    }
  }
  
  
  return TRUE;
}

