//
// util.c
// 낢Ȋ֐
//
// Copyright (c) 2005  N099
//
#include <windows.h>
#include <math.h>
#include <mmintrin.h>

#include "filter.h"
#include "util.h"

// LPF
// [ɃK[hoh邱Ƃ
// E`FbN͂ȂĂ悢
// -108, -192, -191, 35, 615, 1585, 2830, 4089, 5031, 5380 (1<<15)
// -217, -385, -383, 70, 1231, 3170, 5660, 8178, 10063, 10762 (1<<16)
void lpf640(short *dst, const short *src, int n)
{
  int i;
  int tmp;

  for(i=0; i<n; ++i){
    tmp = 1<<15;
    tmp +=  -217 *(src[i-9] + src[i+9]);
    tmp +=  -385 *(src[i-8] + src[i+8]);
    tmp +=  -383 *(src[i-7] + src[i+7]);
    tmp +=    70 *(src[i-6] + src[i+6]);
    tmp +=  1231 *(src[i-5] + src[i+5]);
    tmp +=  3170 *(src[i-4] + src[i+4]);
    tmp +=  5660 *(src[i-3] + src[i+3]);
    tmp +=  8178 *(src[i-2] + src[i+2]);
    tmp += 10063 *(src[i-1] + src[i+1]);
    dst[i] = (tmp + (10762 * src[i]))>>16;
  }
}


// -114, -147, -57, 259, 874, 1776, 2846, 3876, 4623, 4896 (1<<15)
// -228, -294, -115, 518, 1748, 3552, 5693, 7752, 9246, 9792 (1<<16)
void lpf720(short *dst, const short *src, int n)
{
  int i;
  int tmp;

  for(i=0; i<n; ++i){
    tmp = 1<<15;
    tmp += -228 *(src[i-9] + src[i+9]);
    tmp += -294 *(src[i-8] + src[i+8]);
    tmp += -115 *(src[i-7] + src[i+7]);
    tmp +=  518 *(src[i-6] + src[i+6]);
    tmp += 1748 *(src[i-5] + src[i+5]);
    tmp += 3552 *(src[i-4] + src[i+4]);
    tmp += 5693 *(src[i-3] + src[i+3]);
    tmp += 7752 *(src[i-2] + src[i+2]);
    tmp += 9246 *(src[i-1] + src[i+1]);
    dst[i] = (tmp + (9792 * src[i]))>>16;
  }
}

// -86, -10, 599, 30, -2287, -53, 9968, 16446 (1<<15)
// -173, -19, 1198, 59, -4573, -107, 19937, 32892 (1<<16)
void lpfh(short *dst, const short *src, int n)
{
  int i;
  int tmp;

  for(i=0; i<n; ++i){
    tmp = 1<<15;
    tmp +=  -173 *(src[i-7] + src[i+7]);
    tmp +=   -19 *(src[i-6] + src[i+6]);
    tmp +=  1198 *(src[i-5] + src[i+5]);
    tmp +=    59 *(src[i-4] + src[i+4]);
    tmp += -4573 *(src[i-3] + src[i+3]);
    tmp +=  -107 *(src[i-2] + src[i+2]);
    tmp += 19937 *(src[i-1] + src[i+1]);
    dst[i] = (tmp + (32892 * src[i]))>>16;
  }
}

// iq <--> cr,cb ϊ
static const int c_cri = 16899;
static const int c_cbi = -7789;
static const int c_crq = 10974;
static const int c_cbq = 11994;
void crcb2iq(short *cr_i, short *cb_q, int n)
{
  int j;
  int i,q;

  for(j=0; j<n; ++j){
    i = c_cri * cr_i[j] + c_cbi * cb_q[j] + (1<<13);
    q = c_crq * cr_i[j] + c_cbq * cb_q[j] + (1<<13);
    cr_i[j] = i >> 14;
    cb_q[j] = q >> 14;
  }
}

static const int c_icr =  11173;
static const int c_icb = -10223;
static const int c_qcr =   7256;
static const int c_qcb =  15741;
void iq2crcb(short *i_cr, short *q_cb, int n)
{
  int i;
  int cr,cb;

  for(i=0; i<n; ++i){
    cr = c_icr * i_cr[i] + c_qcr * q_cb[i] + (1<<13);
    cb = c_icb * i_cr[i] + c_qcb * q_cb[i] + (1<<13);
    i_cr[i] = cr >> 14;
    q_cb[i] = cb >> 14;
  }
}


// PIXEL_YC ̐FЂƂɓǂݏo YU 2:2
// n : Ƃ̃f[^̉̉f̔
// dst  n + 2*GB ̑傫Ƃ
void unpack_color(short *dst_cr, short *dst_cb, const PIXEL_YC *src, int n)
{
  int i;

  //[
  for(i=0; i<GB; ++i){
    *dst_cr = src->cr;
    *dst_cb = src->cb;

    ++dst_cr;
    ++dst_cb;
  }

  //S
  for(i=0; i<n; ++i){
    *dst_cr = src->cr;
    *dst_cb = src->cb;

    ++dst_cr;
    ++dst_cb;
    src += 2;
  }

  //E[
  src -= 2;
  for(i=0; i<GB; ++i){
    *dst_cr = src->cr;
    *dst_cb = src->cb;

    ++dst_cr;
    ++dst_cb;
  }
}

// YU 4:4 Ƃ PIXEL_YC ɖ߂
// n : Ƃ̃f[^̉̉f
void pack_color(PIXEL_YC *dst, const short *src_cr, const short *src_cb, int n)
{
  int i;

  for(i=0; i<n; ++i){
    dst->cr = *src_cr;
    dst->cb = *src_cb;

    ++dst;
    ++src_cr;
    ++src_cb;
  }
}

// FԂileft origin YUV422 -> YUV444j
// n : src ̉f
// src : \[X
// dst : ] f[^ n*2
void interpolate_color(short *dst, const short *src, int n)
{
  int i;

  //͍Œ6pixelȏƉ
  dst[0] = src[0];
  dst[1] = (9*(src[0] + src[1]) - (src[0] + src[2]) + 8) >> 4;
  --n;
  for(i=1; i<n; ++i){
    dst[2*i] = src[i];
    dst[2*i + 1] = (9*(src[i] + src[i+1]) - (src[i-1] + src[i+2]) + 8) >> 4;
  }
  dst[2*n] = src[n];
  dst[2*n + 1] = (9*(src[n] + src[n]) - (src[n-1] + src[n-1]) + 8) >> 4;
}


// 搬𑫂
// l_dst : in. out.+*2g
// h : in.+
void add_hi(short *l_dst, const short *h, int n, int g)
{
  int j,tmp;

  g *= 2;
  for(j=0; j<n; ++j){
    tmp = h[j] - l_dst[j];
    l_dst[j] +=  (g * tmp) >> 6;
  }
}

// mCŶ߁A臒ll؂̂Ă
//  th  0 ȏł邱Ƃ҂Ă܂B
void add_hi_core(short *l_dst, const short *h, int n, int g, int th)
{
  int j,hi,tmp;

  g *= 2;
  for(j=0; j<n; ++j){
    hi = h[j] - l_dst[j];
    if(hi>0){
      tmp = hi - th;
      if(tmp<0){
        hi += tmp*4;
        hi = hi<0 ? 0 : hi;
      }
    }else{
      tmp = hi + th;
      if(tmp>0){
        hi += tmp*4;
        hi = hi>0 ? 0 : hi;
      }
    }
    l_dst[j] +=  (g * hi) >> 6;
  }
}




