//
// util_mmx.c
// util  MMX 
//
// Copyright (c) 2005  N099
//
#include <windows.h>
#include <mmintrin.h>

#include "filter.h"
#include "util.h"

#define ALIGN8 __declspec(align(8))

// LPF
// [ɃK[hoh邱Ƃ
// E`FbN͂ȂĂ悢
// -217, -385, -383, 70, 1231, 3170, 5660, 8178, 10063, 10762 (1<<16)
void lpf640_mmx(short *dst, const short *src, int n)
{
  int i;
  ALIGN8 static const int rr[2] = { 32768, 32768 };
  ALIGN8 static const short cc0[4] = { -385, -217, -385, -217 };
  ALIGN8 static const short cc1[4] = { 70, -383, 70, -383 };
  ALIGN8 static const short cc2[4] = { 3170, 1231, 3170, 1231 };
  ALIGN8 static const short cc3[4] = { 8178, 5660, 8178, 5660 };
  ALIGN8 static const short cc4[4] = { 10762, 10063, 10762, 10063 };
  __m64 sum0, sum1, r, src0, src1, c0, c1, c2, c3, c4, tmp0;
  
  r = *(__m64 *)rr;
  c0 = *(__m64 *)cc0;
  c1 = *(__m64 *)cc1;
  c2 = *(__m64 *)cc2;
  c3 = *(__m64 *)cc3;
  c4 = *(__m64 *)cc4;
  
  for(i=0; i<n; ++i){
    sum0 = r;
    sum1 = r;
    //
    src0 = _mm_adds_pi16(*(__m64 *)(src+36), *(__m64 *)(src-36));
    src1 = _mm_adds_pi16(*(__m64 *)(src+32), *(__m64 *)(src-32));
    tmp0 = _mm_unpackhi_pi16(src1, src0);
    src1 = _mm_unpacklo_pi16(src1, src0);
    tmp0 = _mm_madd_pi16(tmp0, c0);
    src1 = _mm_madd_pi16(src1, c0);
    sum0 = _mm_add_pi32(sum0, src1);
    sum1 = _mm_add_pi32(sum1, tmp0);
    //
    src0 = _mm_adds_pi16(*(__m64 *)(src+28), *(__m64 *)(src-28));
    src1 = _mm_adds_pi16(*(__m64 *)(src+24), *(__m64 *)(src-24));
    tmp0 = _mm_unpackhi_pi16(src1, src0);
    src1 = _mm_unpacklo_pi16(src1, src0);
    tmp0 = _mm_madd_pi16(tmp0, c1);
    src1 = _mm_madd_pi16(src1, c1);
    sum0 = _mm_add_pi32(sum0, src1);
    sum1 = _mm_add_pi32(sum1, tmp0);
    //
    src0 = _mm_adds_pi16(*(__m64 *)(src+20), *(__m64 *)(src-20));
    src1 = _mm_adds_pi16(*(__m64 *)(src+16), *(__m64 *)(src-16));
    tmp0 = _mm_unpackhi_pi16(src1, src0);
    src1 = _mm_unpacklo_pi16(src1, src0);
    tmp0 = _mm_madd_pi16(tmp0, c2);
    src1 = _mm_madd_pi16(src1, c2);
    sum0 = _mm_add_pi32(sum0, src1);
    sum1 = _mm_add_pi32(sum1, tmp0);
    //
    src0 = _mm_adds_pi16(*(__m64 *)(src+12), *(__m64 *)(src-12));
    src1 = _mm_adds_pi16(*(__m64 *)(src+8), *(__m64 *)(src-8));
    tmp0 = _mm_unpackhi_pi16(src1, src0);
    src1 = _mm_unpacklo_pi16(src1, src0);
    tmp0 = _mm_madd_pi16(tmp0, c3);
    src1 = _mm_madd_pi16(src1, c3);
    sum0 = _mm_add_pi32(sum0, src1);
    sum1 = _mm_add_pi32(sum1, tmp0);
    //
    src0 = _mm_adds_pi16(*(__m64 *)(src+4), *(__m64 *)(src-4));
    src1 = *(__m64 *)src;
    tmp0 = _mm_unpackhi_pi16(src1, src0);
    src1 = _mm_unpacklo_pi16(src1, src0);
    tmp0 = _mm_madd_pi16(tmp0, c4);
    src1 = _mm_madd_pi16(src1, c4);
    sum0 = _mm_add_pi32(sum0, src1);
    sum1 = _mm_add_pi32(sum1, tmp0);
    //
    sum0 = _mm_srai_pi32(sum0, 16);
    sum1 = _mm_srai_pi32(sum1, 16);
    *(__m64 *)dst = _mm_packs_pi32(sum0 ,sum1);

    src += 4;
    dst += 4;
  }
}

// -228, -294, -115, 518, 1748, 3552, 5693, 7752, 9246, 9792 (1<<16)
void lpf720_mmx(short *dst, const short *src, int n)
{
  int i;
  ALIGN8 static const int rr[2] = { 32768, 32768 };
  ALIGN8 static const short cc0[4] = { -294, -228, -294, -228 };
  ALIGN8 static const short cc1[4] = { 518, -115, 518, -115 };
  ALIGN8 static const short cc2[4] = { 3552, 1748, 3552, 1748 };
  ALIGN8 static const short cc3[4] = { 7752, 5693, 7752, 5693 };
  ALIGN8 static const short cc4[4] = { 9792, 9246, 9792, 9246 };
  __m64 sum0, sum1, r, src0, src1, c0, c1, c2, c3, c4, tmp0;
  
  r = *(__m64 *)rr;
  c0 = *(__m64 *)cc0;
  c1 = *(__m64 *)cc1;
  c2 = *(__m64 *)cc2;
  c3 = *(__m64 *)cc3;
  c4 = *(__m64 *)cc4;
  
  for(i=0; i<n; ++i){
    sum0 = r;
    sum1 = r;
    //
    src0 = _mm_adds_pi16(*(__m64 *)(src+36), *(__m64 *)(src-36));
    src1 = _mm_adds_pi16(*(__m64 *)(src+32), *(__m64 *)(src-32));
    tmp0 = _mm_unpackhi_pi16(src1, src0);
    src1 = _mm_unpacklo_pi16(src1, src0);
    tmp0 = _mm_madd_pi16(tmp0, c0);
    src1 = _mm_madd_pi16(src1, c0);
    sum0 = _mm_add_pi32(sum0, src1);
    sum1 = _mm_add_pi32(sum1, tmp0);
    //
    src0 = _mm_adds_pi16(*(__m64 *)(src+28), *(__m64 *)(src-28));
    src1 = _mm_adds_pi16(*(__m64 *)(src+24), *(__m64 *)(src-24));
    tmp0 = _mm_unpackhi_pi16(src1, src0);
    src1 = _mm_unpacklo_pi16(src1, src0);
    tmp0 = _mm_madd_pi16(tmp0, c1);
    src1 = _mm_madd_pi16(src1, c1);
    sum0 = _mm_add_pi32(sum0, src1);
    sum1 = _mm_add_pi32(sum1, tmp0);
    //
    src0 = _mm_adds_pi16(*(__m64 *)(src+20), *(__m64 *)(src-20));
    src1 = _mm_adds_pi16(*(__m64 *)(src+16), *(__m64 *)(src-16));
    tmp0 = _mm_unpackhi_pi16(src1, src0);
    src1 = _mm_unpacklo_pi16(src1, src0);
    tmp0 = _mm_madd_pi16(tmp0, c2);
    src1 = _mm_madd_pi16(src1, c2);
    sum0 = _mm_add_pi32(sum0, src1);
    sum1 = _mm_add_pi32(sum1, tmp0);
    //
    src0 = _mm_adds_pi16(*(__m64 *)(src+12), *(__m64 *)(src-12));
    src1 = _mm_adds_pi16(*(__m64 *)(src+8), *(__m64 *)(src-8));
    tmp0 = _mm_unpackhi_pi16(src1, src0);
    src1 = _mm_unpacklo_pi16(src1, src0);
    tmp0 = _mm_madd_pi16(tmp0, c3);
    src1 = _mm_madd_pi16(src1, c3);
    sum0 = _mm_add_pi32(sum0, src1);
    sum1 = _mm_add_pi32(sum1, tmp0);
    //
    src0 = _mm_adds_pi16(*(__m64 *)(src+4), *(__m64 *)(src-4));
    src1 = *(__m64 *)src;
    tmp0 = _mm_unpackhi_pi16(src1, src0);
    src1 = _mm_unpacklo_pi16(src1, src0);
    tmp0 = _mm_madd_pi16(tmp0, c4);
    src1 = _mm_madd_pi16(src1, c4);
    sum0 = _mm_add_pi32(sum0, src1);
    sum1 = _mm_add_pi32(sum1, tmp0);
    //
    sum0 = _mm_srai_pi32(sum0, 16);
    sum1 = _mm_srai_pi32(sum1, 16);
    *(__m64 *)dst = _mm_packs_pi32(sum0 ,sum1);

    src += 4;
    dst += 4;
  }
}

// -173, -19, 1198, 59, -4573, -107, 19937, 32892(=16446*2) (1<<16)
void lpfh_mmx(short *dst, const short *src, int n)
{
  int i;
  ALIGN8 static const int rr[2] = { 32768, 32768 };
  ALIGN8 static const short cc0[4] = { -19, -173, -19, -173 };
  ALIGN8 static const short cc1[4] = { 59, 1198, 59, 1198 };
  ALIGN8 static const short cc2[4] = { -107, -4573, -107, -4573 };
  ALIGN8 static const short cc3[4] = { 16446, 19937, 16446, 19937 };
  __m64 sum0, sum1, r, src0, src1, c0, c1, c2, c3, tmp0;
  
  r = *(__m64 *)rr;
  c0 = *(__m64 *)cc0;
  c1 = *(__m64 *)cc1;
  c2 = *(__m64 *)cc2;
  c3 = *(__m64 *)cc3;
  
  for(i=0; i<n; ++i){
    sum0 = r;
    sum1 = r;
    //
    src0 = _mm_adds_pi16(*(__m64 *)(src+28), *(__m64 *)(src-28));
    src1 = _mm_adds_pi16(*(__m64 *)(src+24), *(__m64 *)(src-24));
    tmp0 = _mm_unpackhi_pi16(src1, src0);
    src1 = _mm_unpacklo_pi16(src1, src0);
    tmp0 = _mm_madd_pi16(tmp0, c0);
    src1 = _mm_madd_pi16(src1, c0);
    sum0 = _mm_add_pi32(sum0, src1);
    sum1 = _mm_add_pi32(sum1, tmp0);
    //
    src0 = _mm_adds_pi16(*(__m64 *)(src+20), *(__m64 *)(src-20));
    src1 = _mm_adds_pi16(*(__m64 *)(src+16), *(__m64 *)(src-16));
    tmp0 = _mm_unpackhi_pi16(src1, src0);
    src1 = _mm_unpacklo_pi16(src1, src0);
    tmp0 = _mm_madd_pi16(tmp0, c1);
    src1 = _mm_madd_pi16(src1, c1);
    sum0 = _mm_add_pi32(sum0, src1);
    sum1 = _mm_add_pi32(sum1, tmp0);
    //
    src0 = _mm_adds_pi16(*(__m64 *)(src+12), *(__m64 *)(src-12));
    src1 = _mm_adds_pi16(*(__m64 *)(src+8), *(__m64 *)(src-8));
    tmp0 = _mm_unpackhi_pi16(src1, src0);
    src1 = _mm_unpacklo_pi16(src1, src0);
    tmp0 = _mm_madd_pi16(tmp0, c2);
    src1 = _mm_madd_pi16(src1, c2);
    sum0 = _mm_add_pi32(sum0, src1);
    sum1 = _mm_add_pi32(sum1, tmp0);
    //
    src0 = _mm_adds_pi16(*(__m64 *)(src+4), *(__m64 *)(src-4));
    src1 = _mm_adds_pi16(*(__m64 *)src, *(__m64 *)src);
    tmp0 = _mm_unpackhi_pi16(src1, src0);
    src1 = _mm_unpacklo_pi16(src1, src0);
    tmp0 = _mm_madd_pi16(tmp0, c3);
    src1 = _mm_madd_pi16(src1, c3);
    sum0 = _mm_add_pi32(sum0, src1);
    sum1 = _mm_add_pi32(sum1, tmp0);
    //
    sum0 = _mm_srai_pi32(sum0, 16);
    sum1 = _mm_srai_pi32(sum1, 16);
    *(__m64 *)dst = _mm_packs_pi32(sum0 ,sum1);

    src += 4;
    dst += 4;
  }
}

// iq <--> cr,cb ϊ
void crcb2iq_mmx(short *cr_i, short *cb_q, int n)
{
  int j;
  int i,q;
  ALIGN8 static const int rr[2] = { 8192, 8192 };
  ALIGN8 const short ic[4] = { -7789, 16899, -7789, 16899 };
  ALIGN8 const short qc[4] = { 11994, 10974, 11994, 10974 };
  __m64 cr_in, cb_in, i_c, q_c, r, t0, t1;

  i_c = *(__m64 *)ic;
  q_c = *(__m64 *)qc;
  r   = *(__m64 *)rr;

  for(j=n; j>3; j-=4){
    cr_in = *(__m64 *)&cr_i[n-j];
    cb_in = *(__m64 *)&cb_q[n-j];

    t0 = _mm_unpackhi_pi16(cb_in, cr_in);
    t0 = _mm_madd_pi16(t0, i_c);
    t0 = _mm_add_pi32(t0, r);
    t0 = _mm_srai_pi32(t0, 14);
    t1 = _mm_unpacklo_pi16(cb_in, cr_in);
    t1 = _mm_madd_pi16(t1, i_c);
    t1 = _mm_add_pi32(t1, r);
    t1 = _mm_srai_pi32(t1, 14);
    *(__m64 *)&cr_i[n-j] = _mm_packs_pi32(t1 ,t0);
    
    t0 = _mm_unpackhi_pi16(cb_in, cr_in);
    t0 = _mm_madd_pi16(t0, q_c);
    t0 = _mm_add_pi32(t0, r);
    t0 = _mm_srai_pi32(t0, 14);
    t1 = _mm_unpacklo_pi16(cb_in, cr_in);
    t1 = _mm_madd_pi16(t1, q_c);
    t1 = _mm_add_pi32(t1, r);
    t1 = _mm_srai_pi32(t1, 14);
    *(__m64 *)&cb_q[n-j] = _mm_packs_pi32(t1 ,t0);
  }
  for( ; j>0; --j){
    i = ic[1] * cr_i[n-j] + ic[0] * cb_q[n-j] + rr[0];
    q = qc[1] * cr_i[n-j] + qc[0] * cb_q[n-j] + rr[1];
    cr_i[n-j] = i >> 14;
    cb_q[n-j] = q >> 14;
  }
}

void iq2crcb_mmx(short *i_cr, short *q_cb, int n)
{
  int i;
  int cr,cb;
  ALIGN8 static const int rr[2] = { 8192, 8192 };
  ALIGN8 static const short crc[4] = {  7256,  11173,  7256,  11173 };
  ALIGN8 static const short cbc[4] = { 15741, -10223, 15741, -10223 };
  __m64 i_in, q_in, cr_c, cb_c, r, t0, t1;

  cr_c = *(__m64 *)crc;
  cb_c = *(__m64 *)cbc;
  r    = *(__m64 *)rr;
  
  for(i=n; i>3; i-=4){
    i_in = *(__m64 *)&i_cr[n-i];
    q_in = *(__m64 *)&q_cb[n-i];

    t0 = _mm_unpackhi_pi16(q_in, i_in);
    t0 = _mm_madd_pi16(t0, cr_c);
    t0 = _mm_add_pi32(t0, r);
    t0 = _mm_srai_pi32(t0, 14);
    t1 = _mm_unpacklo_pi16(q_in, i_in);
    t1 = _mm_madd_pi16(t1, cr_c);
    t1 = _mm_add_pi32(t1, r);
    t1 = _mm_srai_pi32(t1, 14);
    *(__m64 *)&i_cr[n-i] = _mm_packs_pi32(t1 ,t0);
    
    t0 = _mm_unpackhi_pi16(q_in, i_in);
    t0 = _mm_madd_pi16(t0, cb_c);
    t0 = _mm_add_pi32(t0, r);
    t0 = _mm_srai_pi32(t0, 14);
    t1 = _mm_unpacklo_pi16(q_in, i_in);
    t1 = _mm_madd_pi16(t1, cb_c);
    t1 = _mm_add_pi32(t1, r);
    t1 = _mm_srai_pi32(t1, 14);
    *(__m64 *)&q_cb[n-i] = _mm_packs_pi32(t1 ,t0);
  }
  for(; i>0; --i){
    cr = crc[1] * i_cr[n-i] + crc[0] * q_cb[n-i] + rr[0];
    cb = cbc[1] * i_cr[n-i] + cbc[0] * q_cb[n-i] + rr[1];
    i_cr[n-i] = cr >> 14;
    q_cb[n-i] = cb >> 14;
  }
}

// PIXEL_YC ̐FЂƂɓǂݏo YU 2:2
// n : Ƃ̃f[^̉̉f̔
// dst  n + 2*GB ̑傫Ƃ
// 4line C^[[u
void unpack_color4(short *dst_cr, short *dst_cb, const PIXEL_YC *src, int n, int s)
{
  int i;

  //[
  for(i=0; i<GB; ++i){
    *dst_cr = src->cr;
    *dst_cb = src->cb;

    ++dst_cr;
    ++dst_cb;

    *dst_cr = (src + s)->cr;
    *dst_cb = (src + s)->cb;

    ++dst_cr;
    ++dst_cb;

    *dst_cr = (src + s*2)->cr;
    *dst_cb = (src + s*2)->cb;

    ++dst_cr;
    ++dst_cb;
    
    *dst_cr = (src + s*3)->cr;
    *dst_cb = (src + s*3)->cb;

    ++dst_cr;
    ++dst_cb;
  }

  //S
  for(i=0; i<n; ++i){
    *dst_cr = src->cr;
    *dst_cb = src->cb;

    ++dst_cr;
    ++dst_cb;

    *dst_cr = (src + s)->cr;
    *dst_cb = (src + s)->cb;

    ++dst_cr;
    ++dst_cb;

    *dst_cr = (src + s*2)->cr;
    *dst_cb = (src + s*2)->cb;

    ++dst_cr;
    ++dst_cb;
    
    *dst_cr = (src + s*3)->cr;
    *dst_cb = (src + s*3)->cb;

    ++dst_cr;
    ++dst_cb;
    
    src += 2;
  }

  //E[
  src -= 2;
  for(i=0; i<GB; ++i){
    *dst_cr = src->cr;
    *dst_cb = src->cb;

    ++dst_cr;
    ++dst_cb;

    *dst_cr = (src + s)->cr;
    *dst_cb = (src + s)->cb;

    ++dst_cr;
    ++dst_cb;

    *dst_cr = (src + s*2)->cr;
    *dst_cb = (src + s*2)->cb;

    ++dst_cr;
    ++dst_cb;
    
    *dst_cr = (src + s*3)->cr;
    *dst_cb = (src + s*3)->cb;

    ++dst_cr;
    ++dst_cb;
  }
}

// YU 4:4 Ƃ PIXEL_YC ɖ߂
// n : Ƃ̃f[^̉̉f
// 4line C^[[uĂ
void pack_color4(PIXEL_YC *dst, const short *src_cr, const short *src_cb, int n, int s)
{
  int i;

  for(i=0; i<n; ++i){
    dst->cr = *src_cr;
    dst->cb = *src_cb;
    
    ++src_cr;
    ++src_cb;
    
    (dst + s)->cr = *src_cr;
    (dst + s)->cb = *src_cb;
    
    ++src_cr;
    ++src_cb;
    
    (dst + s*2)->cr = *src_cr;
    (dst + s*2)->cb = *src_cb;
    
    ++src_cr;
    ++src_cb;
    
    (dst + s*3)->cr = *src_cr;
    (dst + s*3)->cb = *src_cb;
    
    ++src_cr;
    ++src_cb;
    
    ++dst;
  }
}

// FԂileft origin YUV422 -> YUV444j
// n : src ̉f
// src : \[X
// dst : ] f[^ n*2
void interpolate_color_mmx(short *dst, const short *src, int n)
{
  int i,l2,l3;
  ALIGN8 static const int cc1[2] = { 8, 8 };
  ALIGN8 static const short cc0[4] = { -1, 9, -1, 9 };
  __m64 c0, c1, s0, s1, s2, s3, t0, t1;
  
  c0 = *(__m64 *)cc0;
  c1 = *(__m64 *)cc1;

  s0 = *(__m64 *)src;
  s1 = s0;
  for(i=0; i<n; ++i){
    l2 = 1+i >=n ? n-1 : i+1;
    l3 = 2+i >=n ? n-1 : i+2;
    s2 = *(__m64 *)(src + l2*4);
    s3 = *(__m64 *)(src + l3*4);
    //
    t0 = _mm_unpackhi_pi16(s0, s1);
    s0 = _mm_unpacklo_pi16(s0, s1);

    t0 = _mm_madd_pi16(t0, c0);
    s0 = _mm_madd_pi16(s0, c0);
    //
    t0 = _mm_add_pi32(t0, c1);
    s0 = _mm_add_pi32(s0, c1);
    //
    t1 = _mm_unpackhi_pi16(s3, s2);
    s3 = _mm_unpacklo_pi16(s3, s2);

    t1 = _mm_madd_pi16(t1, c0);
    s3 = _mm_madd_pi16(s3, c0);
    //
    t0 = _mm_add_pi32(t0, t1);
    s0 = _mm_add_pi32(s0, s3);
    t0 = _mm_srai_pi32(t0, 4);
    s0 = _mm_srai_pi32(s0, 4);
    //
    s0 = _mm_packs_pi32(s0, t0);

    *(__m64 *)dst = s1;
    dst += 4;
    *(__m64 *)dst = s0;
    dst += 4;

    s0 = s1;
    s1 = s2;
  }

}

// 搬𑫂
void add_hi_mmx(short *l_dst, const short *h, int n, int g)
{
  int j,tmp;
  __m64 t0, h0, l0, g0;

  g *= 2;
  g0 = _mm_set_pi16(0, g, g, 0);
  
  for(j=n; j>3; j-=4){
    h0 = *(__m64 *)&h[n-j];
    l0 = *(__m64 *)&l_dst[n-j];

    h0 = _mm_subs_pi16(h0, l0);
    t0 = _mm_srli_si64(h0, 16);
    h0 = _mm_slli_si64(h0, 16);
    t0 = _mm_madd_pi16(t0, g0);
    t0 = _mm_srai_pi32(t0, 6);
    h0 = _mm_madd_pi16(h0, g0);
    h0 = _mm_srai_pi32(h0, 6);
    
    h0 = _mm_packs_pi32(h0 ,t0);
    *(__m64 *)&l_dst[n-j] = _mm_adds_pi16(l0, h0);
  }
  for( ; j>n; --j){
    tmp = h[n-j] - l_dst[n-j];
    l_dst[n-j] +=  (g * tmp) >> 6;
  }
}

// mCŶ߁A臒ll؂̂Ă
//  th  0 ȏł邱Ƃ҂Ă܂B
void add_hi_core_mmx(short *l_dst, const short *h, int n, int g, int th)
{
    int j,hi,tmp;
  __m64 t0, t1, t2, h0, l0, g0, th0, m0, m1;

  g *= 2;
  g0 = _mm_set_pi16(0, g, g, 0);
  th0 = _mm_set1_pi16(th);
  
  for(j=n; j>3; j-=4){
    h0 = *(__m64 *)&h[n-j];
    l0 = *(__m64 *)&l_dst[n-j];

    h0 = _mm_subs_pi16(h0, l0);
    // mask0
    m0 = _mm_setzero_si64();
    m0 = _mm_cmpgt_pi16(m0, h0);

    t0 = _mm_and_si64(h0, m0);// -
    t1 = _mm_setzero_si64();
    t1 = _mm_sub_pi16(t1, t0);
    t0 = _mm_andnot_si64(m0, h0);// +
    t0 = _mm_add_pi16(t0, t1);
    t2 = t0;

    t0 = _mm_sub_pi16(t0, th0);
    //mask1
    m1 = _mm_setzero_si64();
    m1 = _mm_cmpgt_pi16(m1, t0);

    t0 = _mm_slli_pi16(t0, 2);
    t0 = _mm_add_pi16(t0, t2);
    // 0clip
    t1 = _mm_setzero_si64();
    t1 = _mm_cmpgt_pi16(t1, t0);
    t1 = _mm_andnot_si64(t1, t0);

    t0 = _mm_and_si64(m1, t1);
    t1 = _mm_andnot_si64(m1, t2);
    t0 = _mm_add_pi16(t0, t1);

    h0 = _mm_and_si64(t0, m0);//-
    t1 = _mm_setzero_si64();
    t1 = _mm_sub_pi16(t1, h0);
    t0 = _mm_andnot_si64(m0, t0);//+
    h0 = _mm_add_pi16(t1, t0);

    //
    t0 = _mm_srli_si64(h0, 16);
    h0 = _mm_slli_si64(h0, 16);
    t0 = _mm_madd_pi16(t0, g0);
    t0 = _mm_srai_pi32(t0, 6);
    h0 = _mm_madd_pi16(h0, g0);
    h0 = _mm_srai_pi32(h0, 6);
    
    h0 = _mm_packs_pi32(h0 ,t0);
    *(__m64 *)&l_dst[n-j] = _mm_adds_pi16(l0, h0);
  }
  for( ; j>n; --j){
    hi = h[n-j] - l_dst[n-j];
    if(hi>0){
      tmp = hi - th;
      if(tmp<0){
        hi += tmp*4;
        hi = hi<0 ? 0 : hi;
      }
    }else{
      tmp = hi + th;
      if(tmp>0){
        hi += tmp*4;
        hi = hi>0 ? 0 : hi;
      }
    }
    l_dst[n-j] +=  (g * hi) >> 6;
  }
}

